Attribute VB_Name = "rdxint"
' actor is 33(*4) bytes long, but we'll only retrieve
' the first 128 bytes, so as not to goof up the line pointer at
' the bottom.
Public Type actor
       flags As Long
       x As Single
       y As Single
       Height As Single
       eyeheight As Single
       physht As Single
       adjust As Single
       halfwit As Single
       angle As Long
       actortype As Long
       sector As Long
       currframe As Long
       vertforce As Single
       velocity As Single
       range As Single
       damage As Integer
       dambase As Integer
       maxhp As Integer
       curhp As Integer
       used As Integer
       perc_attack  As Integer
       mood As Integer
       target As Integer
       Tag As Integer
       dotype As Integer
       dotag As Integer
       event As Integer
       talkevent  As Integer
       latmov As Integer
       frames As Integer
       Number  As Integer
       mapnumber As Integer
       l As Integer
End Type

Public CurrActor As actor
Private scratchactor As actor
Private scratchptr As Long

Declare Sub FromLp Lib "kernel32" Alias "RtlMoveMemory" _
                (pDest As Any, ByVal lp As Long, ByVal nBytes As Long)
Declare Sub ToLp Lib "kernel32" Alias "RtlMoveMemory" _
                (ByVal lp As Long, pSrc As Any, ByVal nBytes As Long)
                
Public Declare Function dx_getactor Lib "4dxdll.dll" (ByVal actno As Long) As Long
Public Declare Sub dx_fixactor Lib "4dxdll.dll" (ByVal ActPtr As Long)
Public Declare Function dx_getpositionactor Lib "4dxdll.dll" (ByVal actno As Long, ByVal xpos As Single, ByVal ypos As Single, ByVal zpos As Single) As Long
Public Declare Function dx_findsector Lib "4dxdll.dll" (ByVal x As Single, ByVal y As Single) As Long
Public Declare Function dx_getangle Lib "4dxdll.dll" (ByVal x As Single, ByVal y As Single) As Long
Public Declare Function dx_gettime Lib "4dxdll.dll" () As Long
Public Declare Function dx_gettimediff Lib "4dxdll.dll" (ByVal endtime As Long, ByVal starttime As Long) As Long

'Retrieve the whole Actor record, and store it in
'the CurrActor variable
Public Sub RetrieveActor(actorno As Integer)
    scratchptr = dx_getactor(actorno)
    FromLp CurrActor, scratchptr, 128
End Sub
'Refresh the Actor record with what is in CurrActor
'It is dangerous to refresh an actor with the data
'from a different actor! Danger - Do not change
'sectors!
Public Sub RefreshActor(actorno As Integer)
    scratchptr = dx_getactor(actorno)
    ToLp scratchptr, CurrActor, 128
End Sub
Public Sub SetActorPos(actorno As Integer, x As Single, y As Single)
    scratchptr = dx_getactor(actorno)
    FromLp scratchactor, scratchptr, 48
    scratchactor.x = x
    scratchactor.y = y
    scratchactor.sector = dx_findsector(x, y)
    ToLp scratchptr, scratchactor, 48
    dx_fixactor (scratchptr)
End Sub
Public Sub GetActorPos(actorno As Integer, x As Single, y As Single)
    scratchptr = dx_getactor(actorno)
    FromLp scratchactor, scratchptr, 12
    x = scratchactor.x
    y = scratchactor.y
End Sub
